<template>
  <section class="container">
    <!-- <h2>{{ userName }}</h2>
    <h3>{{ age }}</h3> -->
    <p>{{ user }}</p>
    <h2>{{ user.name }}</h2>
    <h3>{{ user.age }}</h3>
    <h2>{{ user2.name }}</h2>
    <h3>{{ user2.age }}</h3>
    <h2>uName: {{ uName }}</h2>
    <h3>uAge: {{ uAge }}</h3>
    <h2>u3Name: {{ u3Name }}</h2>
    <h3>u3Age: {{ u3Age }}</h3>
  </section>
</template>

<script>
import { ref, reactive, isRef, isReactive, toRefs } from 'vue';

export default {
  setup() {
    // const userName = ref('Maximilian');
    // const userAge = ref(31);

    const uAge = ref(31);

    // ref - works with any kind of values: strings, numbers, objects
    const user = ref({
      name: 'Maximilian',
      age: 31,
    });

    // reactive - works with objects only. The object is reactive.
    const user2 = reactive({
      name: 'John',
      age: 40,
    });

    console.log('uAge.value', isRef(uAge.value)); // false
    console.log('user2.name:', isReactive(user2.name)); //false

    console.log('uAge.value', isRef(uAge)); // true
    console.log('user2.name:', isReactive(user2)); // true
    console.log('user2.age: ', user2.age);
    console.log('USER 2 ', user2);

    setTimeout(function () {
      // userName.value = 'Max';
      // userAge.value = 100
      user.value.name = 'Max';
      user.value.age = 190;
    }, 2000);

    setTimeout(function () {
      user2.name = 'Jonny';
      user2.age = 500;
    }, 4000);

    // we can pass any object to the toRefs function. It returns every object`s property wrapped in ref().
    const userRefs = toRefs(user2);
    console.log('userRefs userRefs userRefs: ', userRefs.name);

    const user3 = {
      name: 'Peter',
      age: 600
    };

    const userRefs3 = toRefs(user3);

    setTimeout(() => {
      user3.name = 'Piet';
      user3.age = 700
    }, 3000)
    // if we pass no the ref function a simple value as exmpl: const userName = ref('Maximilian');
    // return { userName, age: userAge }

    // for example user.value.name - does not update the value in the UI
    // in user object: if drilling into the values like 'user.value.name' the changes would not effect on the page. You have to pass the whole 'user' object to the template, not it's values.
    return {
      userName: user.value.name,
      age: user.value.age,
      user,
      user2,
      uName: userRefs.name,
      uAge: userRefs.age,
      u3Name: userRefs3.name,
      u3Age: userRefs3.age,
    };
  },
  // data() {
  //   return {
  //     userName: 'Maximilian',
  //   };
  // },
};
</script>

<style>
* {
  box-sizing: border-box;
}

html {
  font-family: sans-serif;
}

body {
  margin: 0;
}

.container {
  margin: 3rem auto;
  max-width: 30rem;
  border-radius: 12px;
  box-shadow: 0 2px 8px rgba(0, 0, 0, 0.26);
  padding: 1rem;
  text-align: center;
}
</style>
